﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Net;
using System.Diagnostics;
using System.IO;
using System.Threading;

namespace SCI_Narrate
{


    class Program
    {

        static bool changedBit = false;
        static string log_file_SCI = "print.txt";
        static string path = Directory.GetCurrentDirectory();

        static void Main(string[] args)
        {

            Console.WriteLine("SCI Narrate:  Created by Jeremiah Nellis, Aug 5th 2012.  Thanks go to the Google Translate API.");
            Console.WriteLine("Press <enter> key to stop/exit application.");
            FileSystemWatcher watch = new FileSystemWatcher();

            watch.Path = path;

            watch.NotifyFilter = NotifyFilters.LastWrite;

            // Only watch text files.
            watch.Filter = log_file_SCI;

            watch.Changed += new FileSystemEventHandler(OnChanged);

            watch.EnableRaisingEvents = true;
            Console.ReadLine();
        }

        private static void OnChanged(object source, FileSystemEventArgs e)
        {
            int i;
            int j;
            string url;

            changedBit = !changedBit;
            if (changedBit)
            {
                List<string> lines = new List<string>();
                StreamReader r = null;
                int retryCount = 5;

                while (retryCount > 0)
                {
                    try
                    {
                        r = new StreamReader(log_file_SCI);
                        retryCount = -1;
                    }
                    catch
                    {
                        //Console.WriteLine("Failed to open file");
                        retryCount--;
                        Thread.Sleep(250);
                    }
                }

                if (retryCount == 0)
                {
                    return;
                }
  
  
                string line;
                while ((line = r.ReadLine()) != null)
                {
                    //Console.WriteLine("Reading lines from file");
                    lines.Add(line);
                }

                r.Close();
                r.Dispose();
   

                WebClient Client = new WebClient();

                i = 0;
                foreach (string s in lines)
                {
                    //Console.WriteLine("Calling google translate");
                    s.Replace(" ", "+");
                    s.Replace("\"", "");
                    string[] sentences = s.Split(new Char[] { '.', '!', '\n'});
                    foreach (string sentence in sentences)
                    {
                        if (sentence.Length > 100)
                        {
                            string[] parts = sentence.Split(',');
                            foreach (string part in parts)
                            {
                                if (part.Length == 0)
                                {
                                    continue;
                                }
                                url = "http://translate.google.com/translate_tts?ie=UTF-8&tl=en&q=" + part;
                                try
                                {                           
                                    Client.DownloadFile(url, path + "\\output" + i + ".mp3");
                                }
                                catch
                                {
                                    Console.WriteLine("Failed to download: {0}", url);
                                }
                                i++;
                            }


                        } else {
                            if (sentence.Length == 0)
                            {
                                continue;
                            }
                            url = "http://translate.google.com/translate_tts?ie=UTF-8&tl=en&q=" + sentence;
                            try
                            {
                                Client.DownloadFile(url, path + "\\output" + i + ".mp3");
                            }
                            catch
                            {
                                Console.WriteLine("Failed to download: {0}", url);
                            }
                          //Console.WriteLine(s);
                          i++;
                        }
                    }
                }

                j = 0;
                for(j=0; j<i; j++)
                {
                    //Console.WriteLine("Calling madplay");
                    LaunchCommandLineApp(path + "\\output" + j + ".mp3");
                }
            }
            //Console.WriteLine("Bit is set to " + changedBit);
        }


        static void LaunchCommandLineApp(string arguments)
        {

            // Use ProcessStartInfo class
            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.CreateNoWindow = false;
            startInfo.UseShellExecute = false;
            startInfo.FileName = path + "\\madplay.exe";
            startInfo.WindowStyle = ProcessWindowStyle.Hidden;
            startInfo.Arguments = "-q " + "\"" + arguments + "\"";

            try
            {
                // Start the process with the info we specified.
                // Call WaitForExit and then the using statement will close.
                using (Process exeProcess = Process.Start(startInfo))
                {
                    exeProcess.WaitForExit();
                }
            }
            catch
            {
                // Log error.
            }
        }      

    }

}
